clear all

program define htmlcodebook
    version 14
    syntax using/ , SAVing(string) [replace title(string)]
    
    tempname book 
    file open `book' using `saving', write `replace'
    preserve
    qui use "`using'", clear
    
    file write `book' "<!DOCTYPE html>"_n"<html>"_n
    file write `book' "<style>"_n
    file write `book' "body {"_n
    file write `book' "width: 650px;"_n
    file write `book' "margin: auto;"_n
    file write `book' "}"_n
    file write `book' "</style>"_n    
    file write `book' "<body>"_n
    if `"`title'"' != "" {
        file write `book' "<h1>`title'</h1>"_n
    }
    else {
        file write `book' "<h1>Codebook for `using'</h1>"_n
    }
    file write `book' "<h3>Variable list</h3>"
    file write `book' "<ul>"_n
    foreach var of varlist * {
        file write `book' "<li>`var'"                    //new
        if `"`: var label `var''"' != "`var'" {          //new
            file write `book' `": `: var label `var''"'  //new
        }                                                //new
        file write `book' "</li>"_n                      //new
    }
    file write `book' "</ul>"
    file write `book' "</body>"_n
    file write `book' "</html>"_n
    file close `book'
    di as txt "Output written to " `"{browse "`saving'"}"'    
    restore
end

cd h:\stata_l2
htmlcodebook using arc06.dta, saving(test.html) replace

